* extensions.m4 (gl_USE_SYSTEM_EXTENSIONS): Don't #define
[gnulib.git] / gnulib-tool
index 44985c9..362de0e 100755 (executable)
@@ -1,6 +1,6 @@
 #! /bin/sh
 #
-# Copyright (C) 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
+# Copyright (C) 2002-2006 Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -13,8 +13,8 @@
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+# along with this program; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
 # This program is meant for authors or maintainers which want to import
@@ -22,7 +22,7 @@
 
 progname=$0
 package=gnulib
-cvsdatestamp='$Date: 2005-09-19 15:31:32 $'
+cvsdatestamp='$Date: 2006-01-26 12:51:48 $'
 last_checkin_date=`echo "$cvsdatestamp" | sed -e 's,^\$[D]ate: ,,'`
 version=`echo "$last_checkin_date" | sed -e 's/ .*$//' -e 's,/,-,g'`
 
@@ -35,7 +35,23 @@ AUTOCONFPATH=
 #    ;;
 #esac
 
-AUTORECONF="${AUTOCONFPATH}autoreconf"
+# You can set AUTOMAKEPATH to empty if automake 1.9.x is already in your PATH.
+AUTOMAKEPATH=
+
+# If you didn't set AUTOCONFPATH and AUTOMAKEPATH, you can also set the
+# variables AUTOCONF, ACLOCAL, AUTOMAKE, AUTORECONF individually.
+if test -z "${AUTOCONF}" || test -n "${AUTOCONFPATH}"; then
+  AUTOCONF="${AUTOCONFPATH}autoconf"
+fi
+if test -z "${ACLOCAL}" || test -n "${AUTOMAKEPATH}"; then
+  ACLOCAL="${AUTOMAKEPATH}aclocal"
+fi
+if test -z "${AUTOMAKE}" || test -n "${AUTOMAKEPATH}"; then
+  AUTOMAKE="${AUTOMAKEPATH}automake"
+fi
+if test -z "${AUTORECONF}" || test -n "${AUTOCONFPATH}"; then
+  AUTORECONF="${AUTOCONFPATH}autoreconf"
+fi
 
 # func_usage
 # outputs to stdout the --help usage message.
@@ -44,6 +60,7 @@ func_usage ()
   echo "\
 Usage: gnulib-tool --list
        gnulib-tool --import [module1 ... moduleN]
+       gnulib-tool --update
        gnulib-tool --create-testdir --dir=directory module1 ... moduleN
        gnulib-tool --create-megatestdir --dir=directory [module1 ... moduleN]
        gnulib-tool --test --dir=directory module1 ... moduleN
@@ -135,7 +152,7 @@ func_tmpdir ()
   {
     # Use the mktemp program if available. If not available, hide the error
     # message.
-    tmp=`(umask 077 && mktemp -d -q "$TMPDIR/glXXXXXX") 2>/dev/null` &&
+    tmp=`(umask 077 && mktemp -d "$TMPDIR/glXXXXXX") 2>/dev/null` &&
     test -n "$tmp" && test -d "$tmp"
   } ||
   {
@@ -162,6 +179,23 @@ func_fatal_error ()
   exit 1
 }
 
+# func_readlink SYMLINK
+# outputs the target of the given symlink.
+if (type -p readlink) > /dev/null 2>&1; then
+  func_readlink ()
+  {
+    # Use the readlink program from GNU coreutils.
+    readlink "$1"
+  }
+else
+  func_readlink ()
+  {
+    # Use two sed invocations. A single sed -n -e 's,^.* -> \(.*\)$,\1,p'
+    # would do the wrong thing if the link target contains " -> ".
+    LC_ALL=C ls -l "$1" | sed -e 's, -> ,#%%#,' | sed -n -e 's,^.*#%%#\(.*\)$,\1,p'
+  }
+fi
+
 # func_ln_if_changed SRC DEST
 # Like ln -s, but avoids munging timestamps if the link is correct.
 func_ln_if_changed ()
@@ -169,7 +203,7 @@ func_ln_if_changed ()
   if test $# -ne 2; then
     echo "usage: func_ln_if_changed SRC DEST" >&2
   fi
-  if test -L "$2" && test "$1" = "`readlink "$2"`"; then
+  if test -L "$2" && test "$1" = "`func_readlink "$2"`"; then
     :
   else
     rm -f "$2"
@@ -220,6 +254,9 @@ func_ln_if_changed ()
       --import | --impor | --impo | --imp | --im | --i )
         mode=import
         shift ;;
+      --update | --updat | --upda | --upd | --up | --u )
+        mode=update
+        shift ;;
       --create-testdir | --create-testdi | --create-testd | --create-test | --create-tes | --create-te | --create-t )
         mode=create-testdir
         shift ;;
@@ -332,7 +369,7 @@ func_ln_if_changed ()
       --dry-run )
         doit=false
         shift ;;
-      -s | --symbolic | --symlink )
+      -s | --symbolic | --symboli | --symbol | --symbo | --symb | --symlink | --symlin | --symli | --syml | --sym | --sy )
         symbolic=true
         shift ;;
       --help | --hel | --he | --h )
@@ -342,7 +379,7 @@ func_ln_if_changed ()
         func_version
         exit 0 ;;
       -- )
-        # Stop option prcessing
+        # Stop option processing
         shift
         break ;;
       -* )
@@ -353,6 +390,42 @@ func_ln_if_changed ()
         break ;;
     esac
   done
+
+  if test "$mode" = update; then
+    if test $# != 0; then
+      echo "gnulib-tool: too many arguments in 'update' mode" 1>&2
+      echo "Try 'gnulib-tool --help' for more information." 1>&2
+      echo "If you really want to modify the gnulib configuration of your project," 1>&2
+      echo "you need to use 'gnulib --import' - at your own risk!" 1>&2
+      exit 1
+    fi
+    if test -n "$libname" || test -n "$sourcebase" || test -n "$m4base" \
+       || test -n "$testsbase" || test -n "$auxdir" || test -n "$inctests" \
+       || test -n "$avoidlist" || test -n "$lgpl" || test -n "$macro_prefix"; then
+      echo "gnulib-tool: invalid options for 'update' mode" 1>&2
+      echo "Try 'gnulib-tool --help' for more information." 1>&2
+      echo "If you really want to modify the gnulib configuration of your project," 1>&2
+      echo "you need to use 'gnulib --import' - at your own risk!" 1>&2
+      exit 1
+    fi
+    do_changelog=false
+  fi
+
+  # Remove trailing slashes from the directory names. This is necessary for
+  # m4base (to avoid an error in func_import) and optional for the others.
+  sed_trimtrailingslashes='s,\([^/]\)//*$,\1,'
+  case "$sourcebase" in
+    */ ) sourcebase=`echo "$sourcebase" | sed -e "$sed_trimtrailingslashes"` ;;
+  esac
+  case "$m4base" in
+    */ ) m4base=`echo "$m4base" | sed -e "$sed_trimtrailingslashes"` ;;
+  esac
+  case "$testsbase" in
+    */ ) testsbase=`echo "$testsbase" | sed -e "$sed_trimtrailingslashes"` ;;
+  esac
+  case "$auxdir" in
+    */ ) auxdir=`echo "$auxdir" | sed -e "$sed_trimtrailingslashes"` ;;
+  esac
 }
 
 case "$0" in
@@ -371,9 +444,7 @@ case "$0" in
 esac
 while test -h "$self_abspathname"; do
   # Resolve symbolic link.
-  sedexpr1='s, -> ,#%%#,'
-  sedexpr2='s,^.*#%%#\(.*\)$,\1,p'
-  linkval=`LC_ALL=C ls -l "$self_abspathname" | sed -e "$sedexpr1" | sed -n -e "$sedexpr2"`
+  linkval=`func_readlink "$self_abspathname"`
   test -n "$linkval" || break
   case "$linkval" in
     /* ) self_abspathname="$linkval" ;;
@@ -391,7 +462,7 @@ func_all_modules ()
   (cd "$gnulib_dir/modules" && ls -1) \
       | sed -e '/^CVS$/d' -e '/^ChangeLog$/d' -e '/^README$/d' -e '/^TEMPLATE$/d' -e '/^TEMPLATE-TESTS$/d' -e '/~$/d' \
       | sed -e '/-tests$/d' \
-      | sort
+      | LC_ALL=C sort
 }
 
 # func_verify_module
@@ -538,7 +609,7 @@ func_modules_transitive_closure ()
       func_verify_module
       if test -n "$module"; then
         # Duplicate dependencies are harmless, but Jim wants a warning.
-        duplicated_deps=`func_get_dependencies $module | sort | uniq -d`
+        duplicated_deps=`func_get_dependencies $module | LC_ALL=C sort | LC_ALL=C uniq -d`
         if test -n "$duplicated_deps"; then
           echo "warning: module $module has duplicated dependencies: "`echo $duplicated_deps` 1>&2
         fi
@@ -565,7 +636,7 @@ func_modules_transitive_closure ()
         fi
       fi
     done
-    xmodules=`for m in $xmodules; do echo $m; done | sort | uniq`
+    xmodules=`for m in $xmodules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
     if test "$xmodules" = "$modules"; then
       break
     fi
@@ -573,6 +644,40 @@ func_modules_transitive_closure ()
   done
 }
 
+# func_modules_add_dummy
+# Input:
+# - modules         list of modules, including dependencies
+# Output:
+# - modules         list of modules, including 'dummy' if needed
+func_modules_add_dummy ()
+{
+  have_lib_SOURCES=
+  sed_remove_backslash_newline=':a
+/\\$/{
+s/\\$//
+N
+s/\n//
+ba
+}'
+  for module in $modules; do
+    func_verify_nontests_module
+    if test -n "$module"; then
+      # Extract the value of "lib_SOURCES += ...".
+      for file in `func_get_automake_snippet "$module" | sed -e "$sed_remove_backslash_newline" | sed -n -e 's,^lib_SOURCES[   ]*+=\([^#]*\).*$,\1,p'`; do
+        # Ignore .h files since they are not compiled.
+        case "$file" in
+          *.h) ;;
+          *) have_lib_SOURCES=yes ;;
+        esac
+      done
+    fi
+  done
+  # Add the dummy module, to make sure the library will be non-empty.
+  if test -z "$have_lib_SOURCES"; then
+    modules="$modules dummy"
+  fi
+}
+
 # func_modules_to_filelist
 # Input:
 # - modules         list of modules, including dependencies
@@ -587,7 +692,7 @@ func_modules_to_filelist ()
       files="$files "`func_get_filelist $module`
     fi
   done
-  files=`for f in $files; do echo $f; done | sort | uniq`
+  files=`for f in $files; do echo $f; done | LC_ALL=C sort | LC_ALL=C uniq`
 }
 
 # func_emit_lib_Makefile_am
@@ -627,6 +732,7 @@ func_emit_lib_Makefile_am ()
   echo
   echo "${libname}_${libext}_SOURCES ="
   echo "${libname}_${libext}_LIBADD = @${perhapsLT}LIBOBJS@"
+  echo "noinst_HEADERS ="
   echo "EXTRA_DIST ="
   echo "BUILT_SOURCES ="
   echo "SUFFIXES ="
@@ -667,6 +773,8 @@ func_emit_lib_Makefile_am ()
 # - libname         library name
 # - libtool         true if libtool will be used, blank otherwise
 # - sourcebase      relative directory containing lib source code
+# - m4base          relative directory containing autoconf macros
+# - testsbase       relative directory containing unit test code
 func_emit_tests_Makefile_am ()
 {
   if test -n "$libtool"; then
@@ -674,6 +782,7 @@ func_emit_tests_Makefile_am ()
   else
     libext=a
   fi
+  testsbase_inverse=`echo "$testsbase" | sed -e 's,/$,,' | sed -e 's,[^/][^/]*,..,g'`
   echo "## Process this file with automake to produce Makefile.in."
   echo "# Copyright (C) 2004-2005 Free Software Foundation, Inc."
   echo "#"
@@ -688,10 +797,17 @@ func_emit_tests_Makefile_am ()
   # Generate dependencies here, since it eases the debugging of test failures.
   echo "AUTOMAKE_OPTIONS = 1.5 foreign"
   echo
-  echo "ACLOCAL_AMFLAGS = -I ../m4"
+  echo "ACLOCAL_AMFLAGS = -I ${testsbase_inverse}/${m4base}"
   echo
+  # Nothing is being added to SUBDIRS; nevertheless the existence of this
+  # variable is needed to avoid an error from automake:
+  #   "AM_GNU_GETTEXT used but SUBDIRS not defined"
+  echo "SUBDIRS ="
   echo "TESTS ="
+  echo "TESTS_ENVIRONMENT ="
   echo "noinst_PROGRAMS ="
+  echo "check_PROGRAMS ="
+  echo "noinst_HEADERS ="
   echo "EXTRA_DIST ="
   echo "BUILT_SOURCES ="
   echo "SUFFIXES ="
@@ -702,10 +818,10 @@ func_emit_tests_Makefile_am ()
   echo
   echo "AM_CPPFLAGS = \\"
   echo "  -I. -I\$(srcdir) \\"
-  echo "  -I.. -I\$(srcdir)/.. \\"
-  echo "  -I../${sourcebase-lib} -I\$(srcdir)/../${sourcebase-lib}"
+  echo "  -I${testsbase_inverse} -I\$(srcdir)/${testsbase_inverse} \\"
+  echo "  -I${testsbase_inverse}/${sourcebase-lib} -I\$(srcdir)/${testsbase_inverse}/${sourcebase-lib}"
   echo
-  echo "LDADD = ../${sourcebase-lib}/${libname}.${libext}"
+  echo "LDADD = ${testsbase_inverse}/${sourcebase-lib}/${libname}.${libext}"
   echo
   for module in $modules; do
     func_verify_tests_module
@@ -735,7 +851,9 @@ func_emit_tests_Makefile_am ()
 # - libname         library name
 # - sourcebase      directory relative to destdir where to place source code
 # - m4base          directory relative to destdir where to place *.m4 macros
+# - testsbase       directory relative to destdir where to place unit test code
 # - auxdir          directory relative to destdir where to place build aux files
+# - inctests        true if --with-tests was given, blank otherwise
 # - avoidlist       list of modules to avoid, from --avoid
 # - lgpl            true if library's license shall be LGPL, blank otherwise
 # - libtool         true if libtool will be used, blank otherwise
@@ -750,6 +868,7 @@ func_import ()
   cached_avoidlist=
   cached_sourcebase=
   cached_m4base=
+  cached_testsbase=
   cached_libname=
   cached_lgpl=
   cached_libtool=
@@ -772,6 +891,9 @@ func_import ()
       /gl_M4_BASE(/ {
         s,^.*gl_M4_BASE([[ ]*\([^])]*\).*$,cached_m4base="\1",p
       }
+      /gl_TESTS_BASE(/ {
+        s,^.*gl_TESTS_BASE([[ ]*\([^])]*\).*$,cached_testsbase="\1",p
+      }
       /gl_LIB(/ {
         s,^.*gl_LIB([[ ]*\([^])]*\).*$,cached_libname="\1",p
       }
@@ -825,6 +947,13 @@ func_import ()
       func_fatal_error "missing --source-base option"
     fi
   fi
+  # The testsbase defaults to the cached one.
+  if test -z "$testsbase"; then
+    testsbase="$cached_testsbase"
+    if test -z "$testsbase"; then
+      func_fatal_error "missing --tests-base option"
+    fi
+  fi
   # The libname defaults to the cached one.
   if test -z "$supplied_libname"; then
     libname="$cached_libname"
@@ -853,7 +982,7 @@ func_import ()
   fi
 
   # Canonicalize the list of specified modules.
-  specified_modules=`for m in $specified_modules; do echo $m; done | sort | uniq`
+  specified_modules=`for m in $specified_modules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
 
   # Determine final module list.
   modules="$specified_modules"
@@ -861,12 +990,15 @@ func_import ()
   echo "Module list with included dependencies:"
   echo "$modules" | sed -e 's/^/  /'
 
+  # Add the dummy module if needed.
+  func_modules_add_dummy
+
   # If --lgpl, check the license of modules are compatible.
   if test -n "$lgpl"; then
     for module in $modules; do
       license=`func_get_license $module`
       case $license in
-        LGPL | 'public domain' | 'unlimited') ;;
+        LGPL | 'GPLed build tool' | 'public domain' | 'unlimited') ;;
         *) func_fatal_error "incompatible license on module $module: $license" ;;
       esac
     done
@@ -904,6 +1036,16 @@ func_import ()
       echo "Create directory $destdir/$m4base"
     fi
   fi
+  if test -n "$inctests"; then
+    if test ! -d "$destdir/$testsbase"; then
+      if $doit; then
+        echo "Creating directory $destdir/$testsbase"
+        mkdir "$destdir/$testsbase" || func_fatal_error "failed"
+      else
+        echo "Create directory $destdir/$testsbase"
+      fi
+    fi
+  fi
   if test ! -d "$destdir/$auxdir"; then
     if $doit; then
       echo "Creating directory $destdir/$auxdir"
@@ -922,6 +1064,7 @@ func_import ()
       build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
       lib/*) g=`echo "$f" | sed -e "s,^lib/,$cached_sourcebase/,"` ;;
       m4/*) g=`echo "$f" | sed -e "s,^m4/,$cached_m4base/,"` ;;
+      tests/*) g=`echo "$f" | sed -e "s,^tests/,$cached_testsbase/,"` ;;
       *) g="$f" ;;
     esac
     echo "$g""$delimiter""$f"
@@ -931,12 +1074,14 @@ func_import ()
       build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
       lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
       m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
+      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
       *) g="$f" ;;
     esac
     echo "$g""$delimiter""$f"
   done | LC_ALL=C sort > "$tmp"/new-files
   # First the files that are in old-files, but not in new-files:
-  for g in `LC_ALL=C join -t"$delimiter" -v1 "$tmp"/old-files "$tmp"/new-files | sed -e 's,'"$delimiter"'.*,,'`; do
+  sed_take_first_column='s,'"$delimiter"'.*,,'
+  for g in `LC_ALL=C join -t"$delimiter" -v1 "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_first_column"`; do
     # Remove the file. Do nothing if the user already removed it.
     if test -f "$destdir/$g"; then
       if $doit; then
@@ -1006,29 +1151,38 @@ func_import ()
     rm -f "$destdir/$g.tmp"
   }
   # Then the files that are in new-files, but not in old-files:
+  sed_take_last_column='s,^.*'"$delimiter"',,'
   already_present=
-  for f in `LC_ALL=C join -t"$delimiter" -v2 "$tmp"/old-files "$tmp"/new-files | sed -e 's,'^.*"$delimiter"',,'`; do
+  for f in `LC_ALL=C join -t"$delimiter" -v2 "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_last_column"`; do
     case "$f" in
       build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
       lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
       m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
+      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
       *) g="$f" ;;
     esac
     func_add_or_update
   done
   # Then the files that are in new-files and in old-files:
   already_present=true
-  for f in `LC_ALL=C join -t"$delimiter" "$tmp"/old-files "$tmp"/new-files | sed -e 's,'^.*"$delimiter"',,'`; do
+  for f in `LC_ALL=C join -t"$delimiter" "$tmp"/old-files "$tmp"/new-files | sed -e "$sed_take_last_column"`; do
     case "$f" in
       build-aux/*) g=`echo "$f" | sed -e "s,^build-aux/,$auxdir/,"` ;;
       lib/*) g=`echo "$f" | sed -e "s,^lib/,$sourcebase/,"` ;;
       m4/*) g=`echo "$f" | sed -e "s,^m4/,$m4base/,"` ;;
+      tests/*) g=`echo "$f" | sed -e "s,^tests/,$testsbase/,"` ;;
       *) g="$f" ;;
     esac
     func_add_or_update
   done
   rm -rf "$tmp"
-  trap - 0 1 2 3 15
+  # Undo the effect of the previous 'trap' command. Some shellology:
+  # We cannot use "trap - 0 1 2 3 15", because Solaris sh would attempt to
+  # execute the command "-". "trap '' ..." is fine only for signal 0 (= normal
+  # exit); for the others we need to call 'exit' explicitly. The value of $? is
+  # 128 + signal number and is set before the trap-registered command is run.
+  trap '' 0
+  trap 'exit $?' 1 2 3 15
 
   # Command-line invocation printed in a comment in generated gnulib-cache.m4.
   actioncmd="gnulib-tool --import"
@@ -1099,12 +1253,11 @@ func_import ()
     echo "gl_AVOID([$avoidlist])"
     echo "gl_SOURCE_BASE([$sourcebase])"
     echo "gl_M4_BASE([$m4base])"
+    echo "gl_TESTS_BASE([$testsbase])"
     echo "gl_LIB([$libname])"
     test -z "$lgpl" || echo "gl_LGPL"
     test -z "$libtool" || echo "gl_LIBTOOL"
     echo "gl_MACRO_PREFIX([$macro_prefix])"
-    echo
-    echo "# gnulib-cache.m4 ends here"
   ) > "$destdir"/$m4base/gnulib-cache.m4.tmp
   if test -f "$destdir"/$m4base/gnulib-cache.m4; then
     if cmp "$destdir"/$m4base/gnulib-cache.m4 "$destdir"/$m4base/gnulib-cache.m4.tmp > /dev/null; then
@@ -1116,7 +1269,11 @@ func_import ()
         mv -f "$destdir"/$m4base/gnulib-cache.m4.tmp "$destdir"/$m4base/gnulib-cache.m4
       else
         echo "Update $m4base/gnulib-cache.m4 (backup in $m4base/gnulib-cache.m4~)"
-        cat "$destdir"/$m4base/gnulib-cache.m4.tmp
+        if false; then
+          cat "$destdir"/$m4base/gnulib-cache.m4.tmp
+          echo
+          echo "# gnulib-cache.m4 ends here"
+        fi
         rm -f "$destdir"/$m4base/gnulib-cache.m4.tmp
       fi
     fi
@@ -1153,22 +1310,45 @@ func_import ()
     echo "# any checks for libraries, header files, types and library functions."
     echo "AC_DEFUN([${macro_prefix}_EARLY],"
     echo "["
+    echo "  AC_REQUIRE([AC_PROG_RANLIB])"
     if grep AC_GNU_SOURCE "$destdir"/$m4base/*.m4 > /dev/null; then
       echo "  AC_REQUIRE([AC_GNU_SOURCE])"
     fi
     if grep gl_USE_SYSTEM_EXTENSIONS "$destdir"/$m4base/*.m4 > /dev/null; then
       echo "  AC_REQUIRE([gl_USE_SYSTEM_EXTENSIONS])"
     fi
+    if grep gl_LOCK "$destdir"/$m4base/*.m4 > /dev/null; then
+      echo "  AC_REQUIRE([gl_LOCK])"
+    fi
     echo "])"
     echo
     echo "# This macro should be invoked from $configure_ac, in the section"
     echo "# \"Check for header files, types and library functions\"."
     echo "AC_DEFUN([${macro_prefix}_INIT],"
     echo "["
+    if test -z "$libtool"; then
+      echo "  AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+    else
+      echo "  AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+    fi
+    if test "$auxdir" != "build-aux"; then
+      sed_replace_build_aux='
+        :a
+        /AC_CONFIG_FILES(.*:build-aux\/.*)/{
+          s|AC_CONFIG_FILES(\(.*\):build-aux/\(.*\))|AC_CONFIG_FILES(\1:'"$auxdir"'/\2)|
+          ba
+        }'
+      sed_replace_build_aux=`echo "$sed_replace_build_aux" | sed -e 1d -e 's/^ *//'`
+    else
+      sed_replace_build_aux=
+    fi
     for module in $modules; do
       func_verify_module
       if test -n "$module"; then
-        func_get_autoconf_snippet "$module" | sed -e '/^$/d;' -e 's/^/  /' -e 's/AM_GNU_GETTEXT(\[external\])/dnl you must add AM_GNU_GETTEXT([external]) or similar to configure.ac./'
+        func_get_autoconf_snippet "$module" \
+          | sed -e '/^$/d;' -e 's/^/  /' \
+                -e 's/AM_GNU_GETTEXT(\[external\])/dnl you must add AM_GNU_GETTEXT([external]) or similar to configure.ac./' \
+                -e "$sed_replace_build_aux"
         if test "$module" = 'alloca' && test -n "$libtool"; then
           echo 'changequote(,)dnl'
           echo 'LTALLOCA=`echo "$ALLOCA" | sed '"'"'s/\.[^.]* /.lo /g;s/\.[^.]*$/.lo/'"'"'`'
@@ -1184,8 +1364,6 @@ func_import ()
     echo "AC_DEFUN([${macro_prefix}_FILE_LIST], ["
     echo "$files" | sed -e 's,^,  ,'
     echo "])"
-    echo
-    echo "# gnulib-comp.m4 ends here"
   ) > "$destdir"/$m4base/gnulib-comp.m4.tmp
   if test -f "$destdir"/$m4base/gnulib-comp.m4; then
     if cmp "$destdir"/$m4base/gnulib-comp.m4 "$destdir"/$m4base/gnulib-comp.m4.tmp > /dev/null; then
@@ -1197,7 +1375,11 @@ func_import ()
         mv -f "$destdir"/$m4base/gnulib-comp.m4.tmp "$destdir"/$m4base/gnulib-comp.m4
       else
         echo "Update $m4base/gnulib-comp.m4 (backup in $m4base/gnulib-comp.m4~)"
-        cat "$destdir"/$m4base/gnulib-comp.m4.tmp
+        if false; then
+          cat "$destdir"/$m4base/gnulib-comp.m4.tmp
+          echo
+          echo "# gnulib-comp.m4 ends here"
+        fi
         rm -f "$destdir"/$m4base/gnulib-comp.m4.tmp
       fi
     fi
@@ -1212,6 +1394,33 @@ func_import ()
     fi
   fi
 
+  if test -n "$inctests"; then
+    # Create tests/Makefile.am.
+    func_emit_tests_Makefile_am > "$destdir"/$testsbase/Makefile.am.tmp
+    if test -f "$destdir"/$testsbase/Makefile.am; then
+      if cmp "$destdir"/$testsbase/Makefile.am "$destdir"/$testsbase/Makefile.am.tmp > /dev/null; then
+        rm -f "$destdir"/$testsbase/Makefile.am.tmp
+      else
+        if $doit; then
+          echo "Updating $testsbase/Makefile.am (backup in $testsbase/Makefile.am~)"
+          mv -f "$destdir"/$testsbase/Makefile.am "$destdir"/$testsbase/Makefile.am~
+          mv -f "$destdir"/$testsbase/Makefile.am.tmp "$destdir"/$testsbase/Makefile.am
+        else
+          echo "Update $testsbase/Makefile.am (backup in $testsbase/Makefile.am~)"
+          rm -f "$destdir"/$testsbase/Makefile.am.tmp
+        fi
+      fi
+    else
+      if $doit; then
+        echo "Creating $testsbase/Makefile.am"
+        mv -f "$destdir"/$testsbase/Makefile.am.tmp "$destdir"/$testsbase/Makefile.am
+      else
+        echo "Create $testsbase/Makefile.am"
+        rm -f "$destdir"/$testsbase/Makefile.am.tmp
+      fi
+    fi
+  fi
+
   echo "Finished."
   echo
   echo "You may need to add #include directives for the following .h files."
@@ -1221,9 +1430,17 @@ func_import ()
   echo
   echo "Don't forget to"
   echo "  - add \"$sourcebase/Makefile\" to AC_CONFIG_FILES in $configure_ac,"
+  if test -n "$inctests"; then
+    echo "  - add \"$testsbase/Makefile\" to AC_CONFIG_FILES in $configure_ac,"
+  fi
   sourcebase_dir=`echo "$sourcebase" | sed -n -e 's,/[^/]*$,/,p'`
   sourcebase_base=`basename "$sourcebase"`
   echo "  - mention \"${sourcebase_base}\" in SUBDIRS in ${sourcebase_dir}Makefile.am,"
+  if test -n "$inctests"; then
+    testsbase_dir=`echo "$testsbase" | sed -n -e 's,/[^/]*$,/,p'`
+    testsbase_base=`basename "$testsbase"`
+    echo "  - mention \"${testsbase_base}\" in SUBDIRS in ${testsbase_dir}Makefile.am,"
+  fi
   echo "  - mention \"-I ${m4base}\" in ACLOCAL_AMFLAGS in Makefile.am,"
   echo "  - invoke ${macro_prefix}_EARLY in $configure_ac, right after AC_PROG_CC,"
   echo "  - invoke ${macro_prefix}_INIT in $configure_ac."
@@ -1236,13 +1453,16 @@ func_create_testdir ()
 {
   testdir="$1"
   modules="$2"
-  modules=`for m in $modules; do echo $m; done | sort | uniq`
+  modules=`for m in $modules; do echo $m; done | LC_ALL=C sort | LC_ALL=C uniq`
 
   # Determine final module list.
   func_modules_transitive_closure
   echo "Module list with included dependencies:"
   echo "$modules" | sed -e 's/^/  /'
 
+  # Add the dummy module if needed.
+  func_modules_add_dummy
+
   # Determine final file list.
   func_modules_to_filelist
   echo "File list:"
@@ -1304,6 +1524,8 @@ func_create_testdir ()
     test -d "$testdir/tests" || mkdir "$testdir/tests"
     # Create tests/Makefile.am.
     sourcebase=lib
+    m4base=m4
+    testsbase=tests
     func_emit_tests_Makefile_am > "$testdir/tests/Makefile.am"
     # Create tests/configure.ac.
     (echo "# Process this file with autoconf to produce a configure script."
@@ -1326,19 +1548,41 @@ func_create_testdir ()
        echo "gl_USE_SYSTEM_EXTENSIONS"
        echo
      fi
+     if grep gl_LOCK "$testdir"/m4/*.m4 > /dev/null; then
+       echo "gl_LOCK"
+       echo
+     fi
+     if test -z "$libtool"; then
+       echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+     else
+       echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+     fi
+     if test "$auxdir" != "build-aux"; then
+       sed_replace_build_aux='
+         :a
+         /AC_CONFIG_FILES(.*:build-aux\/.*)/{
+           s|AC_CONFIG_FILES(\(.*\):build-aux/\(.*\))|AC_CONFIG_FILES(\1:../'"$auxdir"'/\2)|
+           ba
+         }'
+       sed_replace_build_aux=`echo "$sed_replace_build_aux" | sed -e 1d -e 's/^ *//'`
+     else
+       sed_replace_build_aux=
+     fi
      # We don't have explicit ordering constraints between the various
      # autoconf snippets. It's cleanest to put those of the library before
      # those of the tests.
      for module in $modules; do
        func_verify_nontests_module
        if test -n "$module"; then
-         func_get_autoconf_snippet "$module"
+         func_get_autoconf_snippet "$module" \
+           | sed -e "$sed_replace_build_aux"
        fi
      done
      for module in $modules; do
        func_verify_tests_module
        if test -n "$module"; then
-         func_get_autoconf_snippet "$module"
+         func_get_autoconf_snippet "$module" \
+           | sed -e "$sed_replace_build_aux"
        fi
      done
      echo
@@ -1385,10 +1629,31 @@ func_create_testdir ()
      echo "gl_USE_SYSTEM_EXTENSIONS"
      echo
    fi
+   if grep gl_LOCK "$testdir"/m4/*.m4 > /dev/null; then
+     echo "gl_LOCK"
+     echo
+   fi
+   if test -z "$libtool"; then
+     echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [false])"
+   else
+     echo "AM_CONDITIONAL([GL_COND_LIBTOOL], [true])"
+   fi
+   if test "$auxdir" != "build-aux"; then
+     sed_replace_build_aux='
+       :a
+       /AC_CONFIG_FILES(.*:build-aux\/.*)/{
+         s|AC_CONFIG_FILES(\(.*\):build-aux/\(.*\))|AC_CONFIG_FILES(\1:'"$auxdir"'/\2)|
+         ba
+       }'
+     sed_replace_build_aux=`echo "$sed_replace_build_aux" | sed -e 1d -e 's/^ *//'`
+   else
+     sed_replace_build_aux=
+   fi
    for module in $modules; do
      func_verify_nontests_module
      if test -n "$module"; then
-       func_get_autoconf_snippet "$module"
+       func_get_autoconf_snippet "$module" \
+         | sed -e "$sed_replace_build_aux"
      fi
    done
    echo
@@ -1416,10 +1681,8 @@ func_create_testdir ()
     (cd "$testdir"
      ./configure
        cd lib
-       built_sources=`grep '^BUILT_SOURCES *=' Makefile.in | sed -e 's/^BUILT_SOURCES *=//'`
-       if test -n "$built_sources"; then
-         make $built_sources
-       fi
+       echo 'built_sources: $(BUILT_SOURCES)' >> Makefile
+       make built_sources
        cd ..
      make distclean
     )
@@ -1473,8 +1736,17 @@ func_create_megatestdir ()
 
   # Create autogenerated files.
   (cd "$megatestdir"
-   echo "executing ${AUTORECONF} --install"
-   ${AUTORECONF} --install
+   # Do not use "${AUTORECONF} --install", because autoreconf operates
+   # recursively, but the subdirectories are already finished, therefore
+   # calling autoreconf here would only waste lots of CPU time.
+   echo "executing ${ACLOCAL}"
+   ${ACLOCAL}
+   echo "executing mkdir build-aux"
+   mkdir build-aux
+   echo "executing ${AUTOCONF}"
+   ${AUTOCONF}
+   echo "executing ${AUTOMAKE} --add-missing --copy"
+   ${AUTOMAKE} --add-missing --copy
   )
 }
 
@@ -1486,7 +1758,8 @@ case $mode in
     func_all_modules
     ;;
 
-  import )
+  import | update )
+    
     # Where to import.
     if test -z "$destdir"; then
       destdir=.
@@ -1535,6 +1808,7 @@ case $mode in
         # First use of gnulib in the given m4base.
         test -n "$supplied_libname" || supplied_libname=true
         test -n "$sourcebase" || sourcebase="lib"
+        test -n "$testsbase" || testsbase="tests"
         test -n "$macro_prefix" || macro_prefix="gl"
       fi
       func_import "$*"
@@ -1573,6 +1847,7 @@ case $mode in
         test -n "$supplied_libname" || supplied_libname=true
         test -n "$sourcebase" || sourcebase="lib"
         m4base="m4"
+        test -n "$testsbase" || testsbase="tests"
         test -n "$macro_prefix" || macro_prefix="gl"
         func_import "$*"
       else